/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat AG.   You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat AG.

   Copyright (c) 2003 by NetCat AG, www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;


import li.netcat.smartsync.*;

public class DataPanel extends JPanel {
  private static final Font LABELFONT = new Font(null, Font.BOLD, 12);
  private static final Font FIELDFONT = new Font(null, Font.PLAIN, 12);
  private static final Border BORDER = createBorder(0, 0, 0, 0);

  
  public DataPanel(LayoutManager layoutManager) {
    super(layoutManager);
    setBackground(Color.white);
    setBorder(BORDER);
  }
  
  public void setInsets(int top, int left, int bottom, int right) {
    setBorder(createBorder(top, left, bottom, right));
  }
    
  private static Border createBorder(int top, int left, int bottom, int right) {
    return BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white, new Color(102, 102, 102)), BorderFactory.createEmptyBorder(8+top, 16+left, 8+bottom, 16+right));
  }
  
  public JPanel createRecordPanel(JLabel[] labels, JLabel[] fields) {
    JPanel recordPanel = createJPanel(new BorderLayout(5, 5));
    JPanel labelPanel = createJPanel(new GridLayout(-1,1,0,0));
    for (int i=0; i<labels.length; i++) {
      JLabel label = labels[i];
      label.setForeground(Color.black);
      label.setFont(LABELFONT);
      label.setVerticalAlignment(SwingConstants.BOTTOM);
      labelPanel.add(label);
    }
    JPanel fieldPanel = createJPanel(new GridLayout(-1,1,0,0));
    for (int i=0; i<fields.length; i++) {
      JLabel field = fields[i];
      field.setForeground(Color.black);
      field.setFont(FIELDFONT);
      field.setVerticalAlignment(SwingConstants.BOTTOM);
      fieldPanel.add(field);
    }
    recordPanel.add(labelPanel, BorderLayout.WEST);
    recordPanel.add(fieldPanel, BorderLayout.CENTER);
    return recordPanel;
  }
  
  public JPanel createJPanel(LayoutManager manager) {
    JPanel panel = new JPanel(manager);
    panel.setBackground(Color.white);
    return panel;
  }
      



}
