/*******************************************************************

   This software is the confidential  and proprietary information of
   NetCat AG.   You shall not disclose such confidential information
   and shall use it only in accordance with the terms of the license
   agreement you entered into with NetCat AG.

   Copyright (c) 2003 by NetCat AG, www.netcat.li

   Author: Arthur Marxer, Dipl. Informatik-Ing. ETH

*******************************************************************/

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.table.*;

import li.netcat.smartsync.*;
  
public class TaskPanel extends JPanel {
  private static final Font TEXTFONT = new Font(null, Font.BOLD, 12);
  private TaskModel     _taskModel;
  private CardLayout    _cardLayout;
  private JTextArea     _text;
  private ProgressPanel _progressPanel;


  public TaskPanel() {
    super();
    _cardLayout = new CardLayout();
    setLayout(_cardLayout);
    _taskModel = new TaskModel();
    JTable table = new JTable(_taskModel);
    TableColumnModel cm = table.getColumnModel();
    int preferredWidth = 2;
    for (int i=0; i<_taskModel.getColumnCount(); i++) {
      int pw = _taskModel.getPreferredColumnWidth(i);
      preferredWidth += pw + 2;
      cm.getColumn(i).setPreferredWidth(pw);
    }
    table.setPreferredScrollableViewportSize(new Dimension(preferredWidth, 300));
    _text = new JTextArea();
    _text.setFont(TEXTFONT);
    _text.setEditable(false);
    _text.setBorder(BorderFactory.createEmptyBorder(9, 17, 8, 16));
    _progressPanel = new ProgressPanel();
    JPanel p = new JPanel(new BorderLayout(5, 5));
    p.add(_progressPanel, BorderLayout.NORTH);
    JScrollPane scrollPane = new JScrollPane(table);
    scrollPane.getViewport().setBackground(Color.white);
    p.add(scrollPane, BorderLayout.CENTER);
    add(new JScrollPane(_text), "text");
    add(p, "table");
  }
  
  //// public methods
  
  public void showText() {
    _cardLayout.show(this, "text");
  }

  public void showTable() {
    _cardLayout.show(this, "table");
  }
  
  public void setText(String text) {
    _text.setText(text);
    showText();
  }
  
  public void addTask(Task task) {
    _taskModel.addTask(task);
    showTable();
  }
  
  public void setCurrentTask(Task task) {
    _taskModel.setCurrentTask(task);
    showTable();
  }
  
  public void setTransferProgress(TransferProgress data) {
    _progressPanel.setTransferProgress(data);
    showTable();
  }

  public void setTaskCompleted(Task task) {
    _taskModel.setTaskCompleted(task);
    showTable();
  }

  public void setTaskFailed(Task task) {
    _taskModel.setTaskFailed(task);
    showTable();
  }

}
